import {
    request
} from "../../../utils/api"

// student/pages/correcting/correcting.js
Page({

    /**
     * 页面的初始数据
     */
    data: {
        wH: 0,
        imgPath: '',
        workId: 0,
        workDetail: {},
        noWorkId:0,
        noWorkDetail: {},

    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        this.setData({
            workId: options.workId,
            noWorkId:options.noWorkId
        })
        let {
            windowHeight
        } = wx.getSystemInfoSync()
        this.setData({
            wH: windowHeight
        })
        this.getDetail()
    },
    async getDetail() {
        let {
            data
        } = await request("/app-api/tutor/h5/getStudentHomeworkDetail", "GET", {
            id: this.data.workId
        })
        console.log(data)
        let obj = data
        obj.homeworkPath = obj.homeworkPath.replace('/www/wwwroot/', 'https://')
        this.setData({
            workDetail: obj
        })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {
        this.getDetail()
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})